// -------------------------------------------------------------------
//Whollysteve combined AI arty script
//
//FORWARD-OBSERVER
//
//from
//Nou's Forward Observer Script v0.5 and
//[ZSU]Blake aka Blakeace's AI Artillery Framework v1.00
//15/05/2010
//
//USAGE
//One Forward observer; artillery battery synched to an arty module. thats it.
//Put the folder with bith scripts into the mission folder (or mydocs>arma2>scripts for use in the editor)
//The map is unpacked to allow for use in the editor, just drop it into mydocs>arma2>missions.
//
//Put the following into the FO init box:
//stuff = [FO_NAME,ARTY_MODULE_NAME,WAIT_TIME,FIRE_AT_SIDE,RANGE,TYPE,SPREAD,ADJUSTS,SALVO,SKILL,VEL_COMPENSATOR,PREP_VALUE] execVM 

"fo\forward_observer.sqf";
//eg: stuff = [this,ARTY,1,west,1000,"HE",200,2,8,5,10,1] execVM "ForwardObserver\ForwardObserver.sqf";
//
//FO_NAME			: Name of the Forward Observer 
//ARTY_MODULE_NAME	: Name of the Arty Module synced to your battery
//WAIT_TIME			: How often does the FO search for targets (1)
//FIRE_AT_SIDE		: Whose parade do you want to rain on (EAST,WEST,INS)
//RANGE				: How far out from the FO to look for targets (1000)
//TYPE				: Type of shot "HE","WP","SMOKE","SADARM","LASER"
//SPREAD			: Salvo dispersion radius (100)
//ADJUSTS			: Number of ranging rounds (2)
//SALVO				: Number of shots in the salvo
//SKILL				: How good is the arty battery 0-10 bad-good (5)
//VEL_COMPENSATOR	: Takes into account moving targets (10)
//PREP_VALUE		: Is the unit already ranged in 0 no, 1 yes (0)
//
//Some general values are given in brackets
//
//ENJOY
//
//THANKS TO: Nou's (Forward Observer Script v0.5) and [ZSU]Blake aka Blakeace (AI Artillery Framework v1.00) for the two great scripts that were the main basis for this piece of work.
//
//made with Notepad++
// -------------------------------------------------------------------

sleep 5;	// This needs to be figured out better, probably needs to watch the arty modules and see when they are done with init.
_fo 			= _this select 0;
_battery 		= _this select 1;
_wait 			= _this select 2;  //this is in minutes, min 1 minutes;
_side 			= _this select 3;
_range			= _this select 4;  //search radius;
_type			= _this select 5;  //round type HE,WP,SMOKE,SADARM,LASER;
_spread			= _this select 6;  //spread radius;
_adjustments	= _this select 7;  //number of ranging rounds;
_rounds 		= _this select 8;
_skill			= _this select 9;  //0-10 bad-good skilled;
_adjmult 		= _this select 10; //speed adjuster;
_prep			= _this select 11; //prep value;

_isAssigned = _fo getVariable "FO_Assigned";

_forceMultiplier = 1;

_lastMission = [-10000,-10000,0];

if (_wait < 0.5) then { _wait = 0.5; };

if (isNil "_isAssigned") then {
	_fo setVariable ["FO_Assigned", 1, true];
	while {(alive _fo and [_battery] call BIS_ARTY_F_StillViable)} do {
		_mostCount = 0;
		_target = null;
		_units = nearestObjects [_fo, ["LandVehicle", "CAManBase"], _range];
		player sideChat "Looking for targets...";
		{
			if (side _x == _side and alive _x) then {
				//player sideChat "Found...";
				_liveCount = 0;
				_objects = [];
				
				_near = nearestObjects [_x, ["LandVehicle", "CAManBase"], 100];
				_liveCount = 0;
				_objects = [];
				{
					if(side _x == _side and alive _x and (damage _x) < 0.5) then {
						_liveCount = _liveCount + 1;
						_objects = _objects + [_x];
					};
				} forEach _near;
				
				
				
				if(_liveCount > _mostCount and (_x distance _lastMission) > 120) then {
					_forceMultiplier = 1;
					player sideChat format["Distance from last mission: %1", (_x distance _lastMission)];
					_tanks = "Tank" countType _objects;
					_forceMultiplier = _forceMultiplier + (_tanks * 0.33);
					_apcs = "Wheeled_APC" countType _objects;
					_forceMultiplier = _forceMultiplier + (_apcs * 0.25);
					_mostCount = _liveCount;
					_lastMission = getPos _x;
					if((leader _x) != _x and ((leader _x) distance _x) <= 100) then {
						_target = leader _x;
					} else {
						_target = _x;
					};
				};
				//player sideChat format["Objects near %1: %2", _x, (count _near)];

				sleep 0.025;
			}
		} forEach _units;
		if( isNil "_target") then {
			_lastMission = [-10000,-10000,0];
			player sideChat "No targets found near the FO";
		} else {

			//player sideChat format["Target is: %1 counting for %2 units total.", _target, _mostCount];
			
			player sideChat format["Executing fire mission on %1", _target];
			
			_fo setVariable ["FO_MissionComplete", false, true];

			stuff = [_battery,_target,_mostCount,_fo,_forceMultiplier,_type,_spread,_adjustments,_rounds,_skill,_adjmult,_prep] execVM "ForwardObserver\FireMission.sqf";
			
			player sideChat "Waiting for FO to finish mission";
			
			waitUntil { _fo getVariable "FO_MissionComplete"; };
			
			player sideChat "FO has finished mission";
		};
		player sideChat format["Waiting %1 minutes till next search.", _wait];
		sleep (round (_wait*60));
	}
} else {
	player sideChat "FO is already searching for targets";
};
player sideChat format["FO %1 is no longer operating!", _fo];